diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/build_msg.c olsrd-current/src/build_msg.c
--- olsrd-0.5.0/src/build_msg.c	2006-12-14 12:29:19.000000000 +0100
+++ olsrd-current/src/build_msg.c	2007-04-26 00:08:07.000000000 +0200
@@ -36,10 +36,9 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: build_msg.c,v 1.33 2006/12/14 11:29:19 bernd67 Exp $
+ * $Id: build_msg.c,v 1.36 2007/04/25 22:08:07 bernd67 Exp $
  */
 
-
 #include "defs.h"
 #include "olsr.h"
 #include "log.h"
@@ -113,7 +112,7 @@
  * empty TC messages
  */
 clock_t
-get_empty_tc_timer()
+get_empty_tc_timer(void)
 {
   return send_empty_tc;
 }
@@ -137,7 +136,7 @@
 queue_hello(struct hello_message *message, struct interface *ifp)
 {
 #ifdef DEBUG
-  OLSR_PRINTF(BMSG_DBGLVL, "Building HELLO on %s\n-------------------\n", ifp->int_name)
+  OLSR_PRINTF(BMSG_DBGLVL, "Building HELLO on %s\n-------------------\n", ifp->int_name);
 #endif
 
   switch(olsr_cnf->ip_version)
@@ -168,7 +167,7 @@
 queue_tc(struct tc_message *message, struct interface *ifp)           
 {
 #ifdef DEBUG
-  OLSR_PRINTF(BMSG_DBGLVL, "Building TC on %s\n-------------------\n", ifp->int_name)
+  OLSR_PRINTF(BMSG_DBGLVL, "Building TC on %s\n-------------------\n", ifp->int_name);
 #endif
 
   switch(olsr_cnf->ip_version)
@@ -194,7 +193,7 @@
 queue_mid(struct interface *ifp)
 {
 #ifdef DEBUG
-  OLSR_PRINTF(BMSG_DBGLVL, "Building MID on %s\n-------------------\n", ifp->int_name)
+  OLSR_PRINTF(BMSG_DBGLVL, "Building MID on %s\n-------------------\n", ifp->int_name);
 #endif
 
   switch(olsr_cnf->ip_version)
@@ -219,7 +218,7 @@
 queue_hna(struct interface *ifp)
 {
 #ifdef DEBUG
-  OLSR_PRINTF(BMSG_DBGLVL, "Building HNA on %s\n-------------------\n", ifp->int_name)
+  OLSR_PRINTF(BMSG_DBGLVL, "Building HNA on %s\n-------------------\n", ifp->int_name);
 #endif
 
   switch(olsr_cnf->ip_version)
@@ -242,7 +241,7 @@
 {
   if(msgsize > buffsize)
     {
-      OLSR_PRINTF(1, "%s build, outputbuffer to small(%d/%d)!\n", type, msgsize, buffsize)
+      OLSR_PRINTF(1, "%s build, outputbuffer to small(%d/%d)!\n", type, msgsize, buffsize);
       olsr_syslog(OLSR_LOG_ERR, "%s build, outputbuffer to small(%d/%d)!\n", type, msgsize, buffsize);
       olsr_exit(__func__, EXIT_FAILURE);
     }
@@ -335,8 +334,8 @@
 		continue;
 
 #ifdef DEBUG
-	      OLSR_PRINTF(BMSG_DBGLVL, "\t%s - ", olsr_ip_to_string(&nb->address))
-	      OLSR_PRINTF(BMSG_DBGLVL, "L:%d N:%d\n", j, i)
+	      OLSR_PRINTF(BMSG_DBGLVL, "\t%s - ", olsr_ip_to_string(&nb->address));
+	      OLSR_PRINTF(BMSG_DBGLVL, "L:%d N:%d\n", j, i);
 #endif		  
 	      /*
 	       * If there is not enough room left 
@@ -355,7 +354,7 @@
 		  if(curr_size > OLSR_HELLO_IPV4_HDRSIZE)
 		    {
 #ifdef DEBUG
-		      OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize)
+		      OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize);
 #endif
 		      /* Complete the headers */
 		      m->v4.seqno = htons(get_msg_seqno());
@@ -499,8 +498,8 @@
 		continue;
 
 #ifdef DEBUG
-	      OLSR_PRINTF(BMSG_DBGLVL, "\t%s - ", olsr_ip_to_string(&nb->address))
-	      OLSR_PRINTF(BMSG_DBGLVL, "L:%d N:%d\n", j, i)
+	      OLSR_PRINTF(BMSG_DBGLVL, "\t%s - ", olsr_ip_to_string(&nb->address));
+	      OLSR_PRINTF(BMSG_DBGLVL, "L:%d N:%d\n", j, i);
 #endif		  
 
 
@@ -521,7 +520,7 @@
 		  if(curr_size > OLSR_HELLO_IPV6_HDRSIZE)
 		    {
 #ifdef DEBUG
-		      OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize)
+		      OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize);
 #endif
 		      /* Complete the headers */
 		      m->v6.seqno = htons(get_msg_seqno());
@@ -604,7 +603,7 @@
   olsr_u16_t remainsize, curr_size;
   struct tc_mpr_addr *mprs;
   union olsr_message *m;
-  struct tcmsg *tc;
+  struct olsr_tcmsg *tc;
   struct neigh_info *mprsaddr; 
   olsr_bool found = OLSR_FALSE, partial_sent = OLSR_FALSE;
 
@@ -652,7 +651,7 @@
 	  if(curr_size > OLSR_TC_IPV4_HDRSIZE)
 	    {
 #ifdef DEBUG
-	      OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize)
+	      OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize);
 #endif
 
 	      m->v4.olsr_msgsize = htons(curr_size);
@@ -675,7 +674,7 @@
       found = OLSR_TRUE;
 #ifdef DEBUG
 	  OLSR_PRINTF(BMSG_DBGLVL, "\t%s\n", 
-		      olsr_ip_to_string(&mprs->address))
+		      olsr_ip_to_string(&mprs->address));
 #endif 
       COPY_IP(&mprsaddr->addr, &mprs->address);
 
@@ -697,7 +696,7 @@
       if((!partial_sent) && (!TIMED_OUT(send_empty_tc)))
 	{
 	  if(!TIMED_OUT(send_empty_tc))
-	    OLSR_PRINTF(1, "TC: Sending empty package - (%d/%d/%d/%d)\n", partial_sent, (int)send_empty_tc, (int)now_times, (int)((send_empty_tc) - now_times))
+	    OLSR_PRINTF(1, "TC: Sending empty package - (%d/%d/%d/%d)\n", partial_sent, (int)send_empty_tc, (int)now_times, (int)((send_empty_tc) - now_times));
 
 	  m->v4.olsr_msgsize = htons(curr_size);
 	  m->v4.seqno = htons(get_msg_seqno());
@@ -730,7 +729,7 @@
   olsr_u16_t remainsize, curr_size;
   struct tc_mpr_addr *mprs;
   union olsr_message *m;
-  struct tcmsg6 *tc6;
+  struct olsr_tcmsg6 *tc6;
   struct neigh_info6 *mprsaddr6; 
   olsr_bool found = OLSR_FALSE, partial_sent = OLSR_FALSE;
 
@@ -777,7 +776,7 @@
 	  if(curr_size > OLSR_TC_IPV6_HDRSIZE)
 	    {
 #ifdef DEBUG
-	      OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize)
+	      OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize);
 #endif
 	      m->v6.olsr_msgsize = htons(curr_size);
 	      m->v6.seqno = htons(get_msg_seqno());
@@ -796,7 +795,7 @@
       found = OLSR_TRUE;
 #ifdef DEBUG
 	  OLSR_PRINTF(BMSG_DBGLVL, "\t%s\n", 
-		      olsr_ip_to_string(&mprs->address))
+		      olsr_ip_to_string(&mprs->address));
 #endif
       COPY_IP(&mprsaddr6->addr, &mprs->address);
       curr_size += olsr_cnf->ipsize;
@@ -816,7 +815,7 @@
     {
       if((!partial_sent) && (!TIMED_OUT(send_empty_tc)))
 	{
-	  OLSR_PRINTF(1, "TC: Sending empty package\n")
+	  OLSR_PRINTF(1, "TC: Sending empty package\n");
 	    
 	  m->v6.olsr_msgsize = htons(curr_size);
 	  m->v6.seqno = htons(get_msg_seqno());
@@ -890,7 +889,7 @@
 	      if(curr_size > OLSR_MID_IPV4_HDRSIZE)
 		{
 #ifdef DEBUG
-		  OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize)
+		  OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize);
 #endif
 		  /* set size */
 		  m->v4.olsr_msgsize = htons(curr_size);
@@ -907,7 +906,7 @@
 #ifdef DEBUG
 	  OLSR_PRINTF(BMSG_DBGLVL, "\t%s(%s)\n", 
 		      olsr_ip_to_string(&ifs->ip_addr), 
-		      ifs->int_name)
+		      ifs->int_name);
 #endif
 	  
 	  COPY_IP(&addrs->addr, &ifs->ip_addr);
@@ -989,7 +988,7 @@
 	      if(curr_size > OLSR_MID_IPV6_HDRSIZE)
 		{
 #ifdef DEBUG
-		  OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize)
+		  OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize);
 #endif
 		  /* set size */
 		  m->v6.olsr_msgsize = htons(curr_size);
@@ -1006,7 +1005,7 @@
 #ifdef DEBUG
 		  OLSR_PRINTF(BMSG_DBGLVL, "\t%s(%s)\n", 
 			      olsr_ip_to_string(&ifs->ip_addr), 
-			      ifs->int_name)
+			      ifs->int_name);
 #endif
 
 	  COPY_IP(&addrs6->addr, &ifs->ip_addr);
@@ -1080,7 +1079,7 @@
 	  if(curr_size > OLSR_HNA_IPV4_HDRSIZE)
 	    {
 #ifdef DEBUG
-	      OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize)
+	      OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize);
 #endif
 	      m->v4.seqno = htons(get_msg_seqno());
 	      m->v4.olsr_msgsize = htons(curr_size);
@@ -1095,7 +1094,7 @@
 #ifdef DEBUG
       OLSR_PRINTF(BMSG_DBGLVL, "\tNet: %s/%s\n", 
 		  olsr_ip_to_string(&h->net),
-		  olsr_ip_to_string(&h->netmask))
+		  olsr_ip_to_string(&h->netmask));
 #endif
       COPY_IP(&pair->addr, &h->net);
       COPY_IP(&pair->netmask, &h->netmask);
@@ -1170,7 +1169,7 @@
 	  if(curr_size > OLSR_HNA_IPV6_HDRSIZE)
 	    {
 #ifdef DEBUG
-	      OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize)
+	      OLSR_PRINTF(BMSG_DBGLVL, "Sending partial(size: %d, buff left:%d)\n", curr_size, remainsize);
 #endif
 	      m->v6.seqno = htons(get_msg_seqno());
 	      m->v6.olsr_msgsize = htons(curr_size);
@@ -1185,7 +1184,7 @@
 #ifdef DEBUG
       OLSR_PRINTF(BMSG_DBGLVL, "\tNet: %s/%d\n", 
 		  olsr_ip_to_string(&h->net),
-		  h->prefix_len)
+		  h->prefix_len);
 #endif
       COPY_IP(&pair6->addr, &h->net);
       olsr_prefix_to_netmask(&tmp_netmask, h->prefix_len);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/cfgparser/Makefile olsrd-current/src/cfgparser/Makefile
--- olsrd-0.5.0/src/cfgparser/Makefile	2007-03-27 05:05:21.000000000 +0200
+++ olsrd-current/src/cfgparser/Makefile	2007-05-14 00:02:57.000000000 +0200
@@ -36,7 +36,7 @@
 # to the project. For more information see the website or contact
 # the copyright holders.
 #
-# $Id: Makefile,v 1.22 2007/03/27 03:05:21 tlopatic Exp $
+# $Id: Makefile,v 1.26 2007/05/13 22:02:57 bernd67 Exp $
 
 TOPDIR=../..
 include $(TOPDIR)/Makefile.inc
@@ -89,11 +89,20 @@
 $(NAME):	$(OBJS)
 		$(CC) $(LDFLAGS) -o $(NAME) $(OBJS) $(LIBS)
 
-oscan.c:	oscan.lex
-		$(FLEX) -ooscan.c oscan.lex
+oscan.c:	oscan.lex Makefile
+		$(FLEX) -Cem -ooscan.c-tmp oscan.lex
+		sed	-e '/^static/s/yy_get_next_buffer[\(][\)]/yy_get_next_buffer(void)/' \
+			-e '/^static/s/yy_get_previous_state[\(][\)]/yy_get_previous_state(void)/' \
+			-e '/^static/s/yygrowstack[\(][\)]/yygrowstack(void)/' \
+			-e '/^static/s/input[\(][\)]/input(void)/' \
+			-e '/^static  *void  *yy_fatal_error/s/^\(.*)\);$$/\1 __attribute__((noreturn));/' \
+			< oscan.c-tmp >oscan.c
+		$(RM) oscan.c-tmp
 
-oparse.c:	oparse.y olsrd_conf.h
-		$(BISON) -d -ooparse.c oparse.y
+oparse.c:	oparse.y olsrd_conf.h Makefile
+		$(BISON) -d -o oparse.c oparse.y
+
+#oscan.o oparse.o:: CFLAGS := $(filter-out -Wunreachable-code, $(CFLAGS))
 
 .PHONY: install clean uberclean
 
@@ -102,9 +111,10 @@
 		/sbin/ldconfig -n $(LIBDIR)
 
 clean:
-		rm -f *.[od~]
+		rm -f *.[od~] oscan.c oparse.[ch]
 		rm -f $(LIBNAME)
 		rm -f $(BINNAME)
+		$(RM) oparse.c-tmp
 
 uberclean:	clean
 		rm -f oparse.c oparse.h oscan.c
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/cfgparser/olsrd_conf.c olsrd-current/src/cfgparser/olsrd_conf.c
--- olsrd-0.5.0/src/cfgparser/olsrd_conf.c	2007-03-14 14:59:30.000000000 +0100
+++ olsrd-current/src/cfgparser/olsrd_conf.c	2007-05-14 00:23:55.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_conf.c,v 1.51 2007/03/14 13:59:30 bernd67 Exp $
+ * $Id: olsrd_conf.c,v 1.54 2007/05/13 22:23:55 bernd67 Exp $
  */
 
 
@@ -157,7 +157,6 @@
   while(in)
     {
       /* set various stuff */
-      in->index = cnf->ifcnt++;
       in->configured = OLSR_FALSE;
       in->interf = NULL;
       in->host_emul = OLSR_FALSE;
@@ -419,7 +418,7 @@
 
 
 struct olsrd_config *
-olsrd_get_default_cnf()
+olsrd_get_default_cnf(void)
 {
   cnf = malloc(sizeof(struct olsrd_config));
   if (cnf == NULL)
@@ -481,7 +480,7 @@
 
 
 struct if_config_options *
-get_default_if_config()
+get_default_if_config(void)
 {
   struct if_config_options *io = malloc(sizeof(struct if_config_options));
   struct in6_addr in6;
@@ -731,6 +730,4 @@
   // setbuf(stdout, NULL);
   setbuf(stderr, NULL);
 }
-#else
-void win32_stdio_hack(unsigned int handle) {}
 #endif
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/cfgparser/olsrd_conf.h olsrd-current/src/cfgparser/olsrd_conf.h
--- olsrd-0.5.0/src/cfgparser/olsrd_conf.h	2004-11-30 17:52:16.000000000 +0100
+++ olsrd-current/src/cfgparser/olsrd_conf.h	2007-04-28 22:46:32.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_conf.h,v 1.12 2004/11/30 16:52:16 kattemat Exp $
+ * $Id: olsrd_conf.h,v 1.13 2007/04/28 20:46:32 bernd67 Exp $
  */
 
 
@@ -64,7 +64,11 @@
 void
 set_default_cnf(struct olsrd_config *);
 
+#if defined WIN32_STDIO_HACK
 void 
 win32_stdio_hack(unsigned int);
+#else
+#define win32_stdio_hack(handle) do { } while(0)
+#endif
 
 #endif
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/cfgparser/oparse.y olsrd-current/src/cfgparser/oparse.y
--- olsrd-0.5.0/src/cfgparser/oparse.y	2007-01-31 13:36:50.000000000 +0100
+++ olsrd-current/src/cfgparser/oparse.y	2007-05-13 23:49:59.000000000 +0200
@@ -38,7 +38,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: oparse.y,v 1.31 2007/01/31 12:36:50 bernd67 Exp $
+ * $Id: oparse.y,v 1.33 2007/05/13 21:49:59 bernd67 Exp $
  */
 
 
@@ -55,6 +55,12 @@
 
 #define PARSER_DEBUG 0
 
+#if PARSER_DEBUG
+#define PARSER_DEBUG_PRINTF(x, ...)   printf(x, ##args)
+#else
+#define PARSER_DEBUG_PRINTF(x, ...)   do { } while (0)
+#endif
+
 #define YYSTYPE struct conf_token *
 
 void yyerror(char *);
@@ -121,7 +127,6 @@
 
 %token TOK_OPEN
 %token TOK_CLOSE
-%token TOK_SEMI
 
 %token TOK_STRING
 %token TOK_INTEGER
@@ -154,7 +159,6 @@
 %token TOK_LQ_WSIZE
 %token TOK_LQ_MULT
 %token TOK_CLEAR_SCREEN
-%token TOK_PLNAME
 %token TOK_PLPARAM
 
 %token TOK_HOSTLABEL
@@ -305,7 +309,7 @@
   struct in_addr in;
   struct ipc_host *ipch;
 
-  if(PARSER_DEBUG) printf("\tIPC host: %s\n", $2->string);
+  PARSER_DEBUG_PRINTF("\tIPC host: %s\n", $2->string);
   
   if(inet_aton($2->string, &in) == 0)
     {
@@ -330,7 +334,7 @@
   struct in_addr in1, in2;
   struct ipc_net *ipcn;
 
-  if(PARSER_DEBUG) printf("\tIPC net: %s/%s\n", $2->string, $3->string);
+  PARSER_DEBUG_PRINTF("\tIPC net: %s/%s\n", $2->string, $3->string);
   
   if(inet_aton($2->string, &in1) == 0)
     {
@@ -364,7 +368,7 @@
   int ifcnt = ifs_in_curr_cfg;
   struct olsr_if *ifs = cnf->interfaces;
 
-  if(PARSER_DEBUG) printf("Fixed willingness: %d\n", $2->integer);
+  PARSER_DEBUG_PRINTF("Fixed willingness: %d\n", $2->integer);
 
   while(ifcnt)
     {
@@ -385,7 +389,7 @@
   int ifcnt = ifs_in_curr_cfg;
   struct olsr_if *ifs = cnf->interfaces;
 
-  if(PARSER_DEBUG) printf("\tIPv4 broadcast: %s\n", $2->string);
+  PARSER_DEBUG_PRINTF("\tIPv4 broadcast: %s\n", $2->string);
 
   if(inet_aton($2->string, &in) == 0)
     {
@@ -442,7 +446,7 @@
   int ifcnt = ifs_in_curr_cfg;
   struct olsr_if *ifs = cnf->interfaces;
 
-  if(PARSER_DEBUG) printf("\tIPv6 site-local multicast: %s\n", $2->string);
+  PARSER_DEBUG_PRINTF("\tIPv6 site-local multicast: %s\n", $2->string);
 
   if(inet_pton(AF_INET6, $2->string, &in6) < 0)
     {
@@ -471,7 +475,7 @@
   int ifcnt = ifs_in_curr_cfg;
   struct olsr_if *ifs = cnf->interfaces;
 
-  if(PARSER_DEBUG) printf("\tIPv6 global multicast: %s\n", $2->string);
+  PARSER_DEBUG_PRINTF("\tIPv6 global multicast: %s\n", $2->string);
 
   if(inet_pton(AF_INET6, $2->string, &in6) < 0)
     {
@@ -497,7 +501,7 @@
   int ifcnt = ifs_in_curr_cfg;
   struct olsr_if *ifs = cnf->interfaces;
 
-  if(PARSER_DEBUG) printf("\tHELLO interval: %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("\tHELLO interval: %0.2f\n", $2->floating);
 
   while(ifcnt)
     {
@@ -515,7 +519,7 @@
   int ifcnt = ifs_in_curr_cfg;
   struct olsr_if *ifs = cnf->interfaces;
 
-  if(PARSER_DEBUG) printf("\tHELLO validity: %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("\tHELLO validity: %0.2f\n", $2->floating);
 
   while(ifcnt)
     {
@@ -533,7 +537,7 @@
   int ifcnt = ifs_in_curr_cfg;
   struct olsr_if *ifs = cnf->interfaces;
 
-  if(PARSER_DEBUG) printf("\tTC interval: %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("\tTC interval: %0.2f\n", $2->floating);
 
   while(ifcnt)
     {
@@ -550,7 +554,7 @@
   int ifcnt = ifs_in_curr_cfg;
   struct olsr_if *ifs = cnf->interfaces;
   
-  if(PARSER_DEBUG) printf("\tTC validity: %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("\tTC validity: %0.2f\n", $2->floating);
   while(ifcnt)
     {
       ifs->cnf->tc_params.validity_time = $2->floating;
@@ -568,7 +572,7 @@
   struct olsr_if *ifs = cnf->interfaces;
 
 
-  if(PARSER_DEBUG) printf("\tMID interval: %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("\tMID interval: %0.2f\n", $2->floating);
   while(ifcnt)
     {
       ifs->cnf->mid_params.emission_interval = $2->floating;
@@ -585,7 +589,7 @@
   int ifcnt = ifs_in_curr_cfg;
   struct olsr_if *ifs = cnf->interfaces;
 
-  if(PARSER_DEBUG) printf("\tMID validity: %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("\tMID validity: %0.2f\n", $2->floating);
   while(ifcnt)
     {
       ifs->cnf->mid_params.validity_time = $2->floating;
@@ -602,7 +606,7 @@
   int ifcnt = ifs_in_curr_cfg;
   struct olsr_if *ifs = cnf->interfaces;
   
-  if(PARSER_DEBUG) printf("\tHNA interval: %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("\tHNA interval: %0.2f\n", $2->floating);
   while(ifcnt)
     {
       ifs->cnf->hna_params.emission_interval = $2->floating;
@@ -619,7 +623,7 @@
   int ifcnt = ifs_in_curr_cfg;
   struct olsr_if *ifs = cnf->interfaces;
 
-  if(PARSER_DEBUG) printf("\tHNA validity: %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("\tHNA validity: %0.2f\n", $2->floating);
   while(ifcnt)
     {
       ifs->cnf->hna_params.validity_time = $2->floating;
@@ -636,7 +640,7 @@
   int ifcnt = ifs_in_curr_cfg;
   struct olsr_if *ifs = cnf->interfaces;
 
-  if(PARSER_DEBUG) printf("\tAutodetect changes: %s\n", $2->boolean ? "YES" : "NO");
+  PARSER_DEBUG_PRINTF("\tAutodetect changes: %s\n", $2->boolean ? "YES" : "NO");
   while(ifcnt)
     {
       ifs->cnf->autodetect_chg = $2->boolean;
@@ -673,7 +677,7 @@
 {
 
   cnf->debug_level = $2->integer;
-  if(PARSER_DEBUG) printf("Debug level: %d\n", cnf->debug_level);
+  PARSER_DEBUG_PRINTF("Debug level: %d\n", cnf->debug_level);
   free($2);
 }
 ;
@@ -691,7 +695,7 @@
       YYABORT;
     }
 
-  if(PARSER_DEBUG) printf("IpVersion: %d\n", $2->integer);
+  PARSER_DEBUG_PRINTF("IpVersion: %d\n", $2->integer);
   free($2);
 }
 ;
@@ -702,7 +706,7 @@
   struct hna4_entry *h = malloc(sizeof(struct hna4_entry));
   struct in_addr in;
 
-  if(PARSER_DEBUG) printf("HNA IPv4 entry: %s/%s\n", $1->string, $2->string);
+  PARSER_DEBUG_PRINTF("HNA IPv4 entry: %s/%s\n", $1->string, $2->string);
 
   if(h == NULL)
     {
@@ -740,7 +744,7 @@
   struct hna6_entry *h = malloc(sizeof(struct hna6_entry));
   struct in6_addr in6;
 
-  if(PARSER_DEBUG) printf("HNA IPv6 entry: %s/%d\n", $1->string, $2->integer);
+  PARSER_DEBUG_PRINTF("HNA IPv6 entry: %s/%d\n", $1->string, $2->integer);
 
   if(h == NULL)
     {
@@ -755,7 +759,7 @@
     }
   memcpy(&h->net, &in6, sizeof(struct in6_addr));
 
-  if(($2->integer < 0) || ($2->integer > 128))
+  if($2->integer > 128)
     {
       fprintf(stderr, "ihna6entry: Illegal IPv6 prefix length %d\n", $2->integer);
       return -1;
@@ -775,7 +779,7 @@
 
 ifstart: TOK_INTERFACE
 {
-  if(PARSER_DEBUG) printf("setting ifs_in_curr_cfg = 0\n");
+  PARSER_DEBUG_PRINTF("setting ifs_in_curr_cfg = 0\n");
   ifs_in_curr_cfg = 0;
 }
 ;
@@ -812,7 +816,7 @@
 
 bnoint: TOK_NOINT TOK_BOOLEAN
 {
-  if(PARSER_DEBUG) printf("Noint set to %d\n", $2->boolean);
+  PARSER_DEBUG_PRINTF("Noint set to %d\n", $2->boolean);
 
   cnf->allow_no_interfaces = $2->boolean;
 
@@ -822,7 +826,7 @@
 
 atos: TOK_TOS TOK_INTEGER
 {
-  if(PARSER_DEBUG) printf("TOS: %d\n", $2->integer);
+  PARSER_DEBUG_PRINTF("TOS: %d\n", $2->integer);
   cnf->tos = $2->integer;
 
   free($2);
@@ -834,7 +838,7 @@
 {
   cnf->willingness_auto = OLSR_FALSE;
 
-  if(PARSER_DEBUG) printf("Willingness: %d\n", $2->integer);
+  PARSER_DEBUG_PRINTF("Willingness: %d\n", $2->integer);
   cnf->willingness = $2->integer;
 
   free($2);
@@ -849,11 +853,11 @@
   cnf->use_hysteresis = $2->boolean;
   if(cnf->use_hysteresis)
     {
-      if(PARSER_DEBUG) printf("Hysteresis enabled\n");
+      PARSER_DEBUG_PRINTF("Hysteresis enabled\n");
     }
   else
     {
-      if(PARSER_DEBUG) printf("Hysteresis disabled\n");
+      PARSER_DEBUG_PRINTF("Hysteresis disabled\n");
     }
   free($2);
 
@@ -864,7 +868,7 @@
 fhystscale: TOK_HYSTSCALE TOK_FLOAT
 {
   cnf->hysteresis_param.scaling = $2->floating;
-  if(PARSER_DEBUG) printf("Hysteresis Scaling: %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("Hysteresis Scaling: %0.2f\n", $2->floating);
   free($2);
 }
 ;
@@ -873,7 +877,7 @@
 fhystupper: TOK_HYSTUPPER TOK_FLOAT
 {
   cnf->hysteresis_param.thr_high = $2->floating;
-  if(PARSER_DEBUG) printf("Hysteresis UpperThr: %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("Hysteresis UpperThr: %0.2f\n", $2->floating);
   free($2);
 }
 ;
@@ -882,14 +886,14 @@
 fhystlower: TOK_HYSTLOWER TOK_FLOAT
 {
   cnf->hysteresis_param.thr_low = $2->floating;
-  if(PARSER_DEBUG) printf("Hysteresis LowerThr: %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("Hysteresis LowerThr: %0.2f\n", $2->floating);
   free($2);
 }
 ;
 
 fpollrate: TOK_POLLRATE TOK_FLOAT
 {
-  if(PARSER_DEBUG) printf("Pollrate %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("Pollrate %0.2f\n", $2->floating);
   cnf->pollrate = $2->floating;
 
   free($2);
@@ -898,7 +902,7 @@
 
 fnicchgspollrt: TOK_NICCHGSPOLLRT TOK_FLOAT
 {
-  if(PARSER_DEBUG) printf("NIC Changes Pollrate %0.2f\n", $2->floating);
+  PARSER_DEBUG_PRINTF("NIC Changes Pollrate %0.2f\n", $2->floating);
   cnf->nic_chgs_pollrate = $2->floating;
 
   free($2);
@@ -907,7 +911,7 @@
 
 atcredundancy: TOK_TCREDUNDANCY TOK_INTEGER
 {
-  if(PARSER_DEBUG) printf("TC redundancy %d\n", $2->integer);
+  PARSER_DEBUG_PRINTF("TC redundancy %d\n", $2->integer);
   cnf->tc_redundancy = $2->integer;
   free($2);
 }
@@ -915,7 +919,7 @@
 
 amprcoverage: TOK_MPRCOVERAGE TOK_INTEGER
 {
-  if(PARSER_DEBUG) printf("MPR coverage %d\n", $2->integer);
+  PARSER_DEBUG_PRINTF("MPR coverage %d\n", $2->integer);
   cnf->mpr_coverage = $2->integer;
   free($2);
 }
@@ -923,7 +927,7 @@
 
 alq_level: TOK_LQ_LEVEL TOK_INTEGER
 {
-  if(PARSER_DEBUG) printf("Link quality level %d\n", $2->integer);
+  PARSER_DEBUG_PRINTF("Link quality level %d\n", $2->integer);
   cnf->lq_level = $2->integer;
   free($2);
 }
@@ -931,7 +935,7 @@
 
 alq_fish: TOK_LQ_FISH TOK_INTEGER
 {
-  if(PARSER_DEBUG) printf("Link quality fish eye %d\n", $2->integer);
+  PARSER_DEBUG_PRINTF("Link quality fish eye %d\n", $2->integer);
   cnf->lq_fish = $2->integer;
   free($2);
 }
@@ -939,7 +943,7 @@
 
 alq_dlimit: TOK_LQ_DLIMIT TOK_INTEGER TOK_FLOAT
 {
-  if(PARSER_DEBUG) printf("Link quality dijkstra limit %d, %0.2f\n", $2->integer, $3->floating);
+  PARSER_DEBUG_PRINTF("Link quality dijkstra limit %d, %0.2f\n", $2->integer, $3->floating);
   cnf->lq_dlimit = $2->integer;
   cnf->lq_dinter = $3->floating;
   free($2);
@@ -948,7 +952,7 @@
 
 alq_wsize: TOK_LQ_WSIZE TOK_INTEGER
 {
-  if(PARSER_DEBUG) printf("Link quality window size %d\n", $2->integer);
+  PARSER_DEBUG_PRINTF("Link quality window size %d\n", $2->integer);
   cnf->lq_wsize = $2->integer;
   free($2);
 }
@@ -958,8 +962,7 @@
 {
   cnf->clear_screen = $2->boolean;
 
-  if (PARSER_DEBUG)
-    printf("Clear screen %s\n", cnf->clear_screen ? "enabled" : "disabled");
+  PARSER_DEBUG_PRINTF("Clear screen %s\n", cnf->clear_screen ? "enabled" : "disabled");
 
   free($2);
 }
@@ -979,7 +982,7 @@
 
   pe->params = NULL;
   
-  if(PARSER_DEBUG) printf("Plugin: %s\n", $2->string);
+  PARSER_DEBUG_PRINTF("Plugin: %s\n", $2->string);
 
   /* Queue */
   pe->next = cnf->plugins;
@@ -999,7 +1002,7 @@
       YYABORT;
     }
   
-  if(PARSER_DEBUG) printf("Plugin param key:\"%s\" val: \"%s\"\n", $2->string, $3->string);
+  PARSER_DEBUG_PRINTF("Plugin param key:\"%s\" val: \"%s\"\n", $2->string, $3->string);
   
   pp->key = $2->string;
   pp->value = $3->string;
@@ -1015,7 +1018,7 @@
 
 vcomment:       TOK_COMMENT
 {
-    //if(PARSER_DEBUG) printf("Comment\n");
+    //PARSER_DEBUG_PRINTF("Comment\n");
 }
 ;
 
